diff --git a/target/linux/lantiq/dts/VG3503J.dts b/target/linux/lantiq/dts/VG3503J.dts
index b4b3cf5..36c772d 100644
--- a/target/linux/lantiq/dts/VG3503J.dts
+++ b/target/linux/lantiq/dts/VG3503J.dts
@@ -1,11 +1,183 @@
-/dts-v1/;
-
-/include/ "VG3503J.dtsi"
+/include/ "vr9.dtsi"
 
 / {
+	model = "VG3503J - BT OpenReach VDSL Modem";
+
+	chosen {
+		bootargs = "console=ttyLTQ0,115200 init=/etc/preinit";
+
+		leds {
+			boot = &power_green;
+			failsafe = &power_red;
+			running = &power_green;
+
+			internet = &dsl;
+		};
+	};
+
+	memory@0 {
+		reg = <0x0 0x2000000>;
+	};
+
+	fpi@10000000 {
+		localbus@0 {
+			ranges = <0 0 0x0 0x3ffffff>;
+			nor-boot@0 {
+				compatible = "lantiq,nor";
+				bank-width = <2>;
+				reg = <0 0x0 0x2000000>;
+				#address-cells = <1>;
+				#size-cells = <1>;
+
+				partitions {
+					compatible = "fixed-partitions";
+					#address-cells = <1>;
+					#size-cells = <1>;
+
+					partition@0 {
+						label = "uboot";
+						reg = <0x00000 0x20000>;
+					};
+
+					partition@20000 {
+						label = "kernel";
+						reg = <0x20000 0x300000>;
+					};
+
+					partition@1a0000 {
+						label = "rootfs";
+						reg = <0x320000 0x420000>;
+					};
+
+					partition@740000 {
+						label = "btagent";
+						reg = <0x740000 0x80000>;
+					};
+
+					partition@7c0000 {
+						label = "pri_bfocus_cfg";
+						reg = <0x7c0000 0x10000>;
+					};
+
+					partition@7d0000 {
+						label = "sec_bfocus_cfg";
+						reg = <0x7d0000 0x10000>;
+					};
+
+					partition@7e0000 {
+						label = "sysconfig";
+						reg = <0x7e0000 0x10000>;
+					};
+
+					partition@7f0000 {
+						label = "misc_cfg";
+						reg = <0x7f0000 0x10000>;
+					};
+				};
+			};
+		};
+
+		gpio: pinmux@E100B10 {
+			pinctrl-names = "default";
+			pinctrl-0 = <&state_default>;
+
+			state_default: pinmux {
+				mdio {
+					lantiq,groups = "mdio";
+					lantiq,function = "mdio";
+				};
+				gphy-leds {
+					lantiq,groups = "gphy0 led0", "gphy0 led1",
+							"gphy0 led2", "gphy1 led0",
+							"gphy1 led1", "gphy1 led2";
+					lantiq,function = "gphy";
+					lantiq,pull = <2>;
+					lantiq,open-drain = <0>;
+					lantiq,output = <1>;
+				};
+			};
+		};
+	};
+
 	gphy-xrx200 {
 		compatible = "lantiq,phy-xrx200";
-		firmware = "lantiq/vr9_phy22f_a1x.bin";
+		firmware1 = "lantiq/vr9_phy22f_a1x.bin";	/*VR9 1.1*/
+		firmware2 = "lantiq/vr9_phy22f_a2x.bin";	/*VR9 1.2*/
 		phys = [ 00 01 ];
 	};
+
+	gpio-keys-polled {
+		compatible = "gpio-keys-polled";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		poll-interval = <100>;
+		reset {
+			label = "reset";
+			gpios = <&gpio 6 1>;
+			linux,code = <0x198>;
+		};
+	};
+
+	gpio-leds {
+		compatible = "gpio-leds";
+
+		power_red: power2 {
+			label = "vg3503j:red:power";
+			gpios = <&gpio 14 1>;
+		};
+		dsl: dsl {
+			label = "vg3503j:green:dsl";
+			gpios = <&gpio 19 1>;
+		};
+		power_green: power {
+			label = "vg3503j:green:power";
+			gpios = <&gpio 28 1>;
+			default-state = "keep";
+		};
+	};
+};
+
+&eth0 {
+	interface@0 {
+		compatible = "lantiq,xrx200-pdi";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		reg = <0>;
+		mac-address = [ 00 11 22 33 44 55 ];
+		lantiq,switch;
+		ethernet@2 {
+			compatible = "lantiq,xrx200-pdi-port";
+			reg = <2>;
+			phy-mode = "mii";
+			phy-handle = <&phy11>;
+		};
+		ethernet@4 {
+			compatible = "lantiq,xrx200-pdi-port";
+			reg = <4>;
+			phy-mode = "mii";
+			phy-handle = <&phy13>;
+		};
+	};
+
+	mdio@0 {
+		#address-cells = <1>;
+		#size-cells = <0>;
+		compatible = "lantiq,xrx200-mdio";
+		phy11: ethernet-phy@11 {
+			reg = <0x11>;
+			compatible = "lantiq,phy11g", "ethernet-phy-ieee802.3-c22";
+			lantiq,led1h = <0x70>;
+			lantiq,led1l = <0x00>;
+			lantiq,led2h = <0x00>;
+			lantiq,led2l = <0x03>;
+		};
+		phy13: ethernet-phy@13 {
+			reg = <0x13>;
+			compatible = "lantiq,phy11g", "ethernet-phy-ieee802.3-c22";
+			lantiq,led1h = <0x70>;
+			lantiq,led1l = <0x00>;
+			lantiq,led2h = <0x00>;
+			lantiq,led2l = <0x03>;
+		};
+	};
 };
diff --git a/target/linux/lantiq/dts/VG3503J.dtsi b/target/linux/lantiq/dts/VG3503J.dtsi
deleted file mode 100644
index f68d22c..0000000
--- a/target/linux/lantiq/dts/VG3503J.dtsi
+++ /dev/null
@@ -1,176 +0,0 @@
-/include/ "vr9.dtsi"
-
-/ {
-	model = "VG3503J - BT OpenReach VDSL Modem";
-
-	chosen {
-		bootargs = "console=ttyLTQ0,115200 init=/etc/preinit";
-
-		leds {
-			boot = &power_green;
-			failsafe = &power_red;
-			running = &power_green;
-
-			internet = &dsl;
-		};
-	};
-
-	memory@0 {
-		reg = <0x0 0x2000000>;
-	};
-
-	fpi@10000000 {
-		localbus@0 {
-			ranges = <0 0 0x0 0x3ffffff>;
-			nor-boot@0 {
-				compatible = "lantiq,nor";
-				bank-width = <2>;
-				reg = <0 0x0 0x2000000>;
-				#address-cells = <1>;
-				#size-cells = <1>;
-
-				partitions {
-					compatible = "fixed-partitions";
-					#address-cells = <1>;
-					#size-cells = <1>;
-
-					partition@0 {
-						label = "uboot";
-						reg = <0x00000 0x20000>;
-					};
-
-					partition@20000 {
-						label = "kernel";
-						reg = <0x20000 0x300000>;
-					};
-
-					partition@1a0000 {
-						label = "rootfs";
-						reg = <0x320000 0x420000>;
-					};
-
-					partition@740000 {
-						label = "btagent";
-						reg = <0x740000 0x80000>;
-					};
-
-					partition@7c0000 {
-						label = "pri_bfocus_cfg";
-						reg = <0x7c0000 0x10000>;
-					};
-
-					partition@7d0000 {
-						label = "sec_bfocus_cfg";
-						reg = <0x7d0000 0x10000>;
-					};
-
-					partition@7e0000 {
-						label = "sysconfig";
-						reg = <0x7e0000 0x10000>;
-					};
-
-					partition@7f0000 {
-						label = "misc_cfg";
-						reg = <0x7f0000 0x10000>;
-					};
-				};
-			};
-		};
-
-		gpio: pinmux@E100B10 {
-			pinctrl-names = "default";
-			pinctrl-0 = <&state_default>;
-
-			state_default: pinmux {
-				mdio {
-					lantiq,groups = "mdio";
-					lantiq,function = "mdio";
-				};
-				gphy-leds {
-					lantiq,groups = "gphy0 led0", "gphy0 led1",
-							"gphy0 led2", "gphy1 led0",
-							"gphy1 led1", "gphy1 led2";
-					lantiq,function = "gphy";
-					lantiq,pull = <2>;
-					lantiq,open-drain = <0>;
-					lantiq,output = <1>;
-				};
-			};
-		};
-	};
-
-	gpio-keys-polled {
-		compatible = "gpio-keys-polled";
-		#address-cells = <1>;
-		#size-cells = <0>;
-		poll-interval = <100>;
-		reset {
-			label = "reset";
-			gpios = <&gpio 6 1>;
-			linux,code = <0x198>;
-		};
-	};
-
-	gpio-leds {
-		compatible = "gpio-leds";
-
-		power_red: power2 {
-			label = "vg3503j:red:power";
-			gpios = <&gpio 14 1>;
-		};
-		dsl: dsl {
-			label = "vg3503j:green:dsl";
-			gpios = <&gpio 19 1>;
-		};
-		power_green: power {
-			label = "vg3503j:green:power";
-			gpios = <&gpio 28 1>;
-			default-state = "keep";
-		};
-	};
-};
-
-&eth0 {
-	interface@0 {
-		compatible = "lantiq,xrx200-pdi";
-		#address-cells = <1>;
-		#size-cells = <0>;
-		reg = <0>;
-		mac-address = [ 00 11 22 33 44 55 ];
-		lantiq,switch;
-		ethernet@2 {
-			compatible = "lantiq,xrx200-pdi-port";
-			reg = <2>;
-			phy-mode = "mii";
-			phy-handle = <&phy11>;
-		};
-		ethernet@4 {
-			compatible = "lantiq,xrx200-pdi-port";
-			reg = <4>;
-			phy-mode = "mii";
-			phy-handle = <&phy13>;
-		};
-	};
-
-	mdio@0 {
-		#address-cells = <1>;
-		#size-cells = <0>;
-		compatible = "lantiq,xrx200-mdio";
-		phy11: ethernet-phy@11 {
-			reg = <0x11>;
-			compatible = "lantiq,phy11g", "ethernet-phy-ieee802.3-c22";
-			lantiq,led1h = <0x70>;
-			lantiq,led1l = <0x00>;
-			lantiq,led2h = <0x00>;
-			lantiq,led2l = <0x03>;
-		};
-		phy13: ethernet-phy@13 {
-			reg = <0x13>;
-			compatible = "lantiq,phy11g", "ethernet-phy-ieee802.3-c22";
-			lantiq,led1h = <0x70>;
-			lantiq,led1l = <0x00>;
-			lantiq,led2h = <0x00>;
-			lantiq,led2l = <0x03>;
-		};
-	};
-};
diff --git a/target/linux/lantiq/dts/VG3503J_V2.dts b/target/linux/lantiq/dts/VG3503J_V2.dts
deleted file mode 100644
index 005d5bc..0000000
--- a/target/linux/lantiq/dts/VG3503J_V2.dts
+++ /dev/null
@@ -1,11 +0,0 @@
-/dts-v1/;
-
-/include/ "VG3503J.dtsi"
-
-/ {
-	gphy-xrx200 {
-		compatible = "lantiq,phy-xrx200";
-		firmware = "lantiq/vr9_phy22f_a2x.bin";
-		phys = [ 00 01 ];
-	};
-};
diff --git a/target/linux/lantiq/image/Makefile b/target/linux/lantiq/image/Makefile
index 5f2956c..2b8a3c2 100644
--- a/target/linux/lantiq/image/Makefile
+++ b/target/linux/lantiq/image/Makefile
@@ -435,9 +435,6 @@ Image/Build/Profile/FRITZ3370=$(call Image/BuildEVA/$(1),$(1),FRITZ3370)
 Image/BuildKernel/Profile/VG3503J=$(call Image/BuildKernelLoader/Template,VG3503J)
 Image/Build/Profile/VG3503J=$(call Image/BuildLoader/$(1),$(1),VG3503J)
 
-Image/BuildKernel/Profile/VG3503J_V2=$(call Image/BuildKernelLoader/Template,VG3503J_V2)
-Image/Build/Profile/VG3503J_V2=$(call Image/BuildLoader/$(1),$(1),VG3503J_V2)
-
 $(eval $(call lantiqTpLink,TDW8970,TD-W8970v1))
 $(eval $(call lantiqTpLink,TDW8980,TD-W8980v1))
 $(eval $(call lantiqTpLink,VR200v,ArcherVR200V))
diff --git a/target/linux/lantiq/xrx200/profiles/arv.mk b/target/linux/lantiq/xrx200/profiles/arv.mk
index 3dc22c0..dda5730 100644
--- a/target/linux/lantiq/xrx200/profiles/arv.mk
+++ b/target/linux/lantiq/xrx200/profiles/arv.mk
@@ -4,12 +4,6 @@ endef
 
 $(eval $(call Profile,VG3503J))
 
-define Profile/VG3503J_V2
-  NAME:=BT Openreach - ECI VDSL Modem v2
-endef
-
-$(eval $(call Profile,VG3503J_V2))
-
 define Profile/VGV7510KW22NOR
   NAME:=o2 Box 6431 / Arcadyan VGV7510KW22 (NOR)
   PACKAGES:=kmod-rt2800-pci wpad-mini kmod-usb-dwc2