diff --git a/target/linux/brcm63xx/base-files/etc/board.d/01_leds b/target/linux/brcm63xx/base-files/etc/board.d/01_leds
index 8339254..4163214 100755
--- a/target/linux/brcm63xx/base-files/etc/board.d/01_leds
+++ b/target/linux/brcm63xx/base-files/etc/board.d/01_leds
@@ -24,6 +24,13 @@ dgnd3700v1_dgnd3800b)
 	ucidef_set_led_usbdev "usb1" "USB1" "DGND3700v1_3800B:green:usb-back" "1-1"
 	ucidef_set_led_usbdev "usb2" "USB2" "DGND3700v1_3800B:green:usb-front" "1-2"
 	;;
+evg2000)
+	ucidef_set_led_netdev "lan" "LAN" "EVG2000:green:lan" "eth0"
+	ucidef_set_led_netdev "wan" "WAN" "EVG2000:green:wan" "eth1"
+	ucidef_set_led_netdev "wlan0" "WIFI" "EVG2000:green:wireless" "wlan0"
+	ucidef_set_led_usbdev "usb1" "USB1" "EVG2000:green:voip1" "1-1"
+	ucidef_set_led_usbdev "usb2" "USB2" "EVG2000:green:voip2" "1-2"
+	;;
 fast2704n)
 	ucidef_set_led_netdev "wan" "WAN" "F@ST2704N:green:inet" "eth0.2"
 	;;
diff --git a/target/linux/brcm63xx/base-files/etc/board.d/02_network b/target/linux/brcm63xx/base-files/etc/board.d/02_network
index f96da08..83367c1 100755
--- a/target/linux/brcm63xx/base-files/etc/board.d/02_network
+++ b/target/linux/brcm63xx/base-files/etc/board.d/02_network
@@ -11,6 +11,7 @@ board_config_update
 case "$(brcm63xx_board_name)" in
 
 cvg834g |\
+evg2000 |\
 rta770bw |\
 rta770w |\
 spw303v |\
diff --git a/target/linux/brcm63xx/base-files/etc/diag.sh b/target/linux/brcm63xx/base-files/etc/diag.sh
index b864964..6ac2459 100644
--- a/target/linux/brcm63xx/base-files/etc/diag.sh
+++ b/target/linux/brcm63xx/base-files/etc/diag.sh
@@ -70,6 +70,9 @@ set_state() {
 	dgnd3700v1_dgnd3800b)
 		status_led="DGND3700v1_3800B:green:power"
 		;;
+	evg2000)
+		status_led="EVG2000:green:power"
+		;;
 	fast2504n)
 		status_led="fast2504n:green:ok"
 		;;
diff --git a/target/linux/brcm63xx/base-files/etc/uci-defaults/09_fix_crc b/target/linux/brcm63xx/base-files/etc/uci-defaults/09_fix_crc
index 70dbe2a..1201168 100644
--- a/target/linux/brcm63xx/base-files/etc/uci-defaults/09_fix_crc
+++ b/target/linux/brcm63xx/base-files/etc/uci-defaults/09_fix_crc
@@ -21,6 +21,7 @@ case "$(brcm63xx_board_name)" in
 	cpva642 |\
 	ct-6373 |\
 	dsl-274xb-f |\
+	evg2000 |\
 	hg622 |\
 	magic |\
 	p870hw-51a_v2 |\
@@ -37,4 +38,3 @@ case "$(brcm63xx_board_name)" in
 		do_fixcrc
 		;;
 esac
-
diff --git a/target/linux/brcm63xx/base-files/lib/brcm63xx.sh b/target/linux/brcm63xx/base-files/lib/brcm63xx.sh
index a2d6519..9cc0b2b 100755
--- a/target/linux/brcm63xx/base-files/lib/brcm63xx.sh
+++ b/target/linux/brcm63xx/base-files/lib/brcm63xx.sh
@@ -183,6 +183,9 @@ brcm63xx_dt_detect() {
 	"Netgear DGND3700v1/DGND3800B")
 		board_name="dgnd3700v1_dgnd3800b"
 		;;
+	"Netgear EVG2000")
+		board_name="evg2000"
+		;;
 	"NuCom R5010UN v2")
 		board_name="r5010un_v2"
 		;;
diff --git a/target/linux/brcm63xx/base-files/lib/preinit/05_init_interfaces_brcm63xx b/target/linux/brcm63xx/base-files/lib/preinit/05_init_interfaces_brcm63xx
index 7e4dfcb..1e3fc14 100644
--- a/target/linux/brcm63xx/base-files/lib/preinit/05_init_interfaces_brcm63xx
+++ b/target/linux/brcm63xx/base-files/lib/preinit/05_init_interfaces_brcm63xx
@@ -18,6 +18,7 @@ set_preinit_iface() {
 	dsl-274xb-c |\
 	dsl-274xb-f |\
 	dsl-275xb-d |\
+	evg2000 |\
 	fast2504n |\
 	fast2704v2 |\
 	hg553 |\
diff --git a/target/linux/brcm63xx/dts/evg2000.dts b/target/linux/brcm63xx/dts/evg2000.dts
new file mode 100644
index 0000000..04f7b84
--- /dev/null
+++ b/target/linux/brcm63xx/dts/evg2000.dts
@@ -0,0 +1,103 @@
+/dts-v1/;
+
+#include "bcm6368.dtsi"
+
+#include <dt-bindings/input/input.h>
+
+/ {
+	model = "Netgear EVG2000";
+	compatible = "netgear,evg2000", "brcm,bcm6368";
+
+	gpio-keys-polled {
+		compatible = "gpio-keys-polled";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		poll-interval = <20>;
+		debounce-interval = <60>;
+
+		reset {
+			label = "reset";
+			gpios = <&gpio0 25 1>;
+			linux,code = <KEY_RESTART>;
+		};
+		wps {
+			label = "wps";
+			gpios = <&gpio0 26 1>;
+			linux,code = <KEY_WPS_BUTTON>;
+		};
+	};
+
+	gpio-leds {
+		compatible = "gpio-leds";
+
+		voip1_green {
+			label = "EVG2000:green:voip1";
+			gpios = <&gpio0 14 1>;
+		};
+		voip2_green {
+			label = "EVG2000:green:voip2";
+			gpios = <&gpio0 2 1>;
+		};
+		inet_red {
+			label = "EVG2000:red:inet";
+			gpios = <&gpio0 4 1>;
+		};
+		inet_green {
+			label = "EVG2000:green:inet";
+			gpios = <&gpio0 5 1>;
+		};
+		usb_green {
+			label = "EVG2000:green:usb";
+			gpios = <&gpio0 15 1>;
+		};
+		power_green {
+			label = "EVG2000:green:power";
+			gpios = <&gpio0 22 1>;
+			default-state = "on";
+		};
+		power_red {
+			label = "EVG2000:red:power";
+			gpios = <&gpio0 23 1>;
+		};
+		lan_green {
+			label = "EVG2000:green:lan";
+			gpios = <&gpio0 24 1>;
+		};
+		wireless_green {
+			label = "EVG2000:green:wireless";
+			gpios = <&gpio0 26 1>;
+		};
+		wan_green {
+			label = "EVG2000:green:wan";
+			gpios = <&gpio0 27 1>;
+		};
+	};
+};
+
+&pflash {
+	status = "ok";
+
+	linux,part-probe = "bcm63xxpart";
+
+	cfe@0 {
+			label = "CFE";
+			reg = <0x00000000 0x00020000>;
+			read-only;
+	};
+
+	linux@20000 {
+			label = "linux";
+			reg = <0x00020000 0x00f40000>;
+	};
+
+	board_data@f60000 {
+			label = "board_data";
+			reg = <0x00f60000 0x00080000>;
+			read-only;
+	};
+
+	nvram@fe0000 {
+			label = "nvram";
+			reg = <0x00fe0000 0x00020000>;
+	};
+};
diff --git a/target/linux/brcm63xx/image/Makefile b/target/linux/brcm63xx/image/Makefile
index e00b6fb..f1fb86b 100644
--- a/target/linux/brcm63xx/image/Makefile
+++ b/target/linux/brcm63xx/image/Makefile
@@ -593,6 +593,8 @@ $(eval $(call bcm63xxCfeRamdisk,DG834GV4,DG834GTv4,dg834g_v4,96348W3,6348))
 $(eval $(call bcm63xxCfeNetgear,DGND3700v1_3800B,DGND3700v1,dgnd3700v1,96368MVWG,6368,--image-offset 0x20000 --block-size 0x20000,U12L144T01_NETGEAR_NEWLED,1))
 # Netgear DGND3800B
 $(eval $(call bcm63xxCfeNetgear,DGND3700v1_3800B,DGND3800B,dgnd3700v1,96368MVWG,6368,--image-offset 0x20000 --block-size 0x20000,U12L144T11_NETGEAR_NEWLED,1))
+# Netgear EVG2000
+$(eval $(call bcm63xxCfeNetgear,EVG2000,EVG2000,evg2000,96369PVG,6369,--image-offset 0x20000 --block-size 0x20000,U12H154T90_NETGEAR,1))
 # NuCom R5010UNv2
 $(eval $(call bcm63xxCfe,R5010UNV2,R5010UNv2,r5010unv2,96328ang,6328,--pad 8))
 # Pirelli Alice Gate VoIP 2 Plus Wi-Fi AGPF-S0
diff --git a/target/linux/brcm63xx/patches-4.1/575-board_EVG2000.patch b/target/linux/brcm63xx/patches-4.1/575-board_EVG2000.patch
new file mode 100644
index 0000000..9339085
--- /dev/null
+++ b/target/linux/brcm63xx/patches-4.1/575-board_EVG2000.patch
@@ -0,0 +1,62 @@
+--- a/arch/mips/bcm63xx/boards/board_bcm963xx.c
++++ b/arch/mips/bcm63xx/boards/board_bcm963xx.c
+@@ -2010,6 +2010,43 @@ static struct board_info __initdata boar
+ 	.num_spis = ARRAY_SIZE(DGND3700v1_3800B_spi_devices),
+ };
+ 
++static struct sprom_fixup __initdata EVG2000_fixups[] = {
++  { .offset = 219, .value = 0xec08 },
++};
++
++static struct board_info __initdata board_EVG2000 = {
++	.name				= "96369PVG",
++	.expected_cpu_id		= 0x6368,
++
++	.has_uart0			= 1,
++	.has_pci			= 1,
++	.has_ohci0			= 1,
++	.has_ehci0			= 1,
++	.num_usbh_ports			= 2,
++
++	.has_enetsw			= 1,
++	.enetsw = {
++		.used_ports = {
++			[5] = {
++				.used  = 1,
++				.phy_id  = 0xff,
++				.bypass_link = 1,
++				.force_speed = 1000,
++				.force_duplex_full = 1,
++				.name  = "RGMII",
++			},
++		},
++	},
++	.use_fallback_sprom     = 1,
++	.fallback_sprom = {
++			.type               = SPROM_BCM4322,
++			.pci_bus            = 0,
++			.pci_dev            = 1,
++			.board_fixups			= EVG2000_fixups,
++			.num_board_fixups		= ARRAY_SIZE(EVG2000_fixups),
++	},
++};
++
+ static struct board_info __initdata board_HG655b = {
+ 	.name				= "HW65x",
+ 	.expected_cpu_id		= 0x6368,
+@@ -2610,6 +2647,7 @@ static const struct board_info __initcon
+ 	&board_96368mvwg,
+ 	&board_96368mvngr,
+ 	&board_DGND3700v1_3800B,
++	&board_EVG2000,
+ 	&board_HG622,
+ 	&board_HG655b,
+ 	&board_P870HW51A_V2,
+@@ -2722,6 +2760,7 @@ static struct of_device_id const bcm963x
+ 	{ .compatible = "huawei,hg622", .data = &board_HG622, },
+ 	{ .compatible = "huawei,hg655b", .data = &board_HG655b, },
+ 	{ .compatible = "netgear,dgnd3700v1", .data = &board_DGND3700v1_3800B, },
++	{ .compatible = "netgear,evg2000", .data = &board_EVG2000, },
+ 	{ .compatible = "zyxel,p870hw-51a-v2", .data = &board_P870HW51A_V2, },
+ #endif
+ #ifdef CONFIG_BCM63XX_CPU_63268
diff --git a/target/linux/brcm63xx/patches-4.4/202-MTD-DEVICES-m25p80-use-parsers-if-provided-in-flash-.patch b/target/linux/brcm63xx/patches-4.4/202-MTD-DEVICES-m25p80-use-parsers-if-provided-in-flash-.patch
index be62e67..4793836 100644
--- a/target/linux/brcm63xx/patches-4.4/202-MTD-DEVICES-m25p80-use-parsers-if-provided-in-flash-.patch
+++ b/target/linux/brcm63xx/patches-4.4/202-MTD-DEVICES-m25p80-use-parsers-if-provided-in-flash-.patch
@@ -11,7 +11,7 @@ Signed-off-by: Jonas Gorski <jonas.gorski@gmail.com>
 
 --- a/drivers/mtd/devices/m25p80.c
 +++ b/drivers/mtd/devices/m25p80.c
-@@ -229,7 +229,8 @@ static int m25p_probe(struct spi_device
+@@ -251,7 +251,8 @@ static int m25p_probe(struct spi_device
  
  	ppdata.of_node = spi->dev.of_node;
  
diff --git a/target/linux/brcm63xx/patches-4.4/203-MTD-DEVICES-m25p80-add-support-for-limiting-reads.patch b/target/linux/brcm63xx/patches-4.4/203-MTD-DEVICES-m25p80-add-support-for-limiting-reads.patch
index 3877442..75a874d 100644
--- a/target/linux/brcm63xx/patches-4.4/203-MTD-DEVICES-m25p80-add-support-for-limiting-reads.patch
+++ b/target/linux/brcm63xx/patches-4.4/203-MTD-DEVICES-m25p80-add-support-for-limiting-reads.patch
@@ -28,7 +28,7 @@ Signed-off-by: Jonas Gorski <jonas.gorski@gmail.com>
  			size_t *retlen, u_char *buf)
  {
  	struct m25p *flash = nor->priv;
-@@ -152,6 +153,29 @@ static int m25p80_read(struct spi_nor *n
+@@ -174,6 +175,29 @@ static int m25p80_read(struct spi_nor *n
  	return 0;
  }
  
@@ -58,7 +58,7 @@ Signed-off-by: Jonas Gorski <jonas.gorski@gmail.com>
  static int m25p80_erase(struct spi_nor *nor, loff_t offset)
  {
  	struct m25p *flash = nor->priv;
-@@ -223,6 +247,9 @@ static int m25p_probe(struct spi_device
+@@ -245,6 +269,9 @@ static int m25p_probe(struct spi_device
  	else
  		flash_name = spi->modalias;
  
diff --git a/target/linux/brcm63xx/patches-4.4/414-MTD-m25p80-allow-passing-pp_data.patch b/target/linux/brcm63xx/patches-4.4/414-MTD-m25p80-allow-passing-pp_data.patch
index e421e9a..bbb565e 100644
--- a/target/linux/brcm63xx/patches-4.4/414-MTD-m25p80-allow-passing-pp_data.patch
+++ b/target/linux/brcm63xx/patches-4.4/414-MTD-m25p80-allow-passing-pp_data.patch
@@ -10,7 +10,7 @@ Subject: [PATCH 64/79] MTD: m25p80: allow passing pp_data
 
 --- a/drivers/mtd/devices/m25p80.c
 +++ b/drivers/mtd/devices/m25p80.c
-@@ -250,6 +250,9 @@ static int m25p_probe(struct spi_device
+@@ -272,6 +272,9 @@ static int m25p_probe(struct spi_device
  	if (data)
  		flash->max_transfer_len = data->max_transfer_len;
  
diff --git a/target/linux/brcm63xx/patches-4.4/575-board_EVG2000.patch b/target/linux/brcm63xx/patches-4.4/575-board_EVG2000.patch
new file mode 100644
index 0000000..fc7afc7
--- /dev/null
+++ b/target/linux/brcm63xx/patches-4.4/575-board_EVG2000.patch
@@ -0,0 +1,62 @@
+--- a/arch/mips/bcm63xx/boards/board_bcm963xx.c
++++ b/arch/mips/bcm63xx/boards/board_bcm963xx.c
+@@ -2011,6 +2011,43 @@ static struct board_info __initdata boar
+ 	.num_spis = ARRAY_SIZE(DGND3700v1_3800B_spi_devices),
+ };
+ 
++static struct sprom_fixup __initdata EVG2000_fixups[] = {
++  { .offset = 219, .value = 0xec08 },
++};
++
++static struct board_info __initdata board_EVG2000 = {
++	.name				= "96369PVG",
++	.expected_cpu_id		= 0x6368,
++
++	.has_uart0			= 1,
++	.has_pci			= 1,
++	.has_ohci0			= 1,
++	.has_ehci0			= 1,
++	.num_usbh_ports			= 2,
++
++	.has_enetsw			= 1,
++	.enetsw = {
++		.used_ports = {
++			[5] = {
++				.used  = 1,
++				.phy_id  = 0xff,
++				.bypass_link = 1,
++				.force_speed = 1000,
++				.force_duplex_full = 1,
++				.name  = "RGMII",
++			},
++		},
++	},
++	.use_fallback_sprom     = 1,
++	.fallback_sprom = {
++			.type               = SPROM_BCM4322,
++			.pci_bus            = 0,
++			.pci_dev            = 1,
++			.board_fixups			= EVG2000_fixups,
++			.num_board_fixups		= ARRAY_SIZE(EVG2000_fixups),
++	},
++};
++
+ static struct board_info __initdata board_HG655b = {
+ 	.name				= "HW65x",
+ 	.expected_cpu_id		= 0x6368,
+@@ -2611,6 +2648,7 @@ static const struct board_info __initcon
+ 	&board_96368mvwg,
+ 	&board_96368mvngr,
+ 	&board_DGND3700v1_3800B,
++	&board_EVG2000,
+ 	&board_HG622,
+ 	&board_HG655b,
+ 	&board_P870HW51A_V2,
+@@ -2723,6 +2761,7 @@ static struct of_device_id const bcm963x
+ 	{ .compatible = "huawei,hg622", .data = &board_HG622, },
+ 	{ .compatible = "huawei,hg655b", .data = &board_HG655b, },
+ 	{ .compatible = "netgear,dgnd3700v1", .data = &board_DGND3700v1_3800B, },
++	{ .compatible = "netgear,evg2000", .data = &board_EVG2000, },
+ 	{ .compatible = "zyxel,p870hw-51a-v2", .data = &board_P870HW51A_V2, },
+ #endif
+ #ifdef CONFIG_BCM63XX_CPU_63268
diff --git a/target/linux/brcm63xx/profiles/netgear.mk b/target/linux/brcm63xx/profiles/netgear.mk
index bc345bb..e3bc34a 100644
--- a/target/linux/brcm63xx/profiles/netgear.mk
+++ b/target/linux/brcm63xx/profiles/netgear.mk
@@ -41,3 +41,13 @@ define Profile/DGND3700v1_3800B/Description
   Package set optimized for DGND3700 v1 / DGND3800B.
 endef
 $(eval $(call Profile,DGND3700v1_3800B))
+
+define Profile/EVG2000
+  NAME:=Netgear EVG2000
+  PACKAGES:=kmod-b43 wpad-mini \
+	kmod-usb2 kmod-usb-ohci kmod-ledtrig-usbdev
+endef
+define Profile/EVG2000/Description
+  Package set optimized for EVG2000.
+endef
+$(eval $(call Profile,EVG2000))