diff --git a/target/linux/arc770/Makefile b/target/linux/arc770/Makefile
index 6492529..8b164f4 100644
--- a/target/linux/arc770/Makefile
+++ b/target/linux/arc770/Makefile
@@ -12,7 +12,7 @@ BOARDNAME:=Synopsys DesignWare ARC 770D
 MAINTAINER:=Alexey Brodkin <abrodkin@synopsys.com>
 SUBTARGETS:=generic
 
-KERNEL_PATCHVER:=4.4
+KERNEL_PATCHVER:=4.9
 
 DEVICE_TYPE:=developerboard
 
diff --git a/target/linux/arc770/config-4.4 b/target/linux/arc770/config-4.9
similarity index 82%
rename from target/linux/arc770/config-4.4
rename to target/linux/arc770/config-4.9
index f484de3..2472ce2 100644
--- a/target/linux/arc770/config-4.4
+++ b/target/linux/arc770/config-4.9
@@ -1,9 +1,8 @@
 # CONFIG_16KSTACKS is not set
 CONFIG_ARC=y
-CONFIG_ARCH_HAS_ATOMIC64_DEC_IF_POSITIVE=y
+# CONFIG_ARCH_DISCONTIGMEM_ENABLE is not set
 # CONFIG_ARCH_HAS_GCOV_PROFILE_ALL is not set
 # CONFIG_ARCH_HAS_SG_CHAIN is not set
-CONFIG_ARCH_REQUIRE_GPIOLIB=y
 CONFIG_ARCH_SUPPORTS_ATOMIC_RMW=y
 CONFIG_ARC_BUILTIN_DTB_NAME=""
 CONFIG_ARC_CACHE=y
@@ -16,18 +15,17 @@ CONFIG_ARC_CACHE_PAGES=y
 CONFIG_ARC_CPU_770=y
 CONFIG_ARC_CURR_IN_REG=y
 CONFIG_ARC_DBG=y
-# CONFIG_ARC_DBG_TLB_MISS_COUNT is not set
 # CONFIG_ARC_DBG_TLB_PARANOIA is not set
 CONFIG_ARC_DW2_UNWIND=y
 CONFIG_ARC_EMUL_UNALIGNED=y
 # CONFIG_ARC_FPU_SAVE_RESTORE is not set
 CONFIG_ARC_HAS_DCACHE=y
 # CONFIG_ARC_HAS_DCCM is not set
-CONFIG_ARC_HAS_HW_MPY=y
 CONFIG_ARC_HAS_ICACHE=y
 # CONFIG_ARC_HAS_ICCM is not set
 CONFIG_ARC_HAS_LLSC=y
 CONFIG_ARC_HAS_SWAPE=y
+CONFIG_ARC_KVADDR_SIZE=256
 # CONFIG_ARC_METAWARE_HLINK is not set
 # CONFIG_ARC_MMU_V1 is not set
 # CONFIG_ARC_MMU_V2 is not set
@@ -36,14 +34,18 @@ CONFIG_ARC_MMU_V3=y
 # CONFIG_ARC_PAGE_SIZE_4K is not set
 CONFIG_ARC_PAGE_SIZE_8K=y
 CONFIG_ARC_PLAT_AXS10X=y
+# CONFIG_ARC_PLAT_EZNPS is not set
 CONFIG_ARC_PLAT_SIM=y
 # CONFIG_ARC_PLAT_TB10X is not set
 CONFIG_ARC_UBOOT_SUPPORT=y
 CONFIG_AXS101=y
 CONFIG_CLKDEV_LOOKUP=y
+CONFIG_CLKSRC_OF=y
+CONFIG_CLKSRC_PROBE=y
 CONFIG_CLONE_BACKWARDS=y
 CONFIG_COMMON_CLK=y
 # CONFIG_CPU_BIG_ENDIAN is not set
+CONFIG_CPU_NO_EFFICIENT_FFS=y
 CONFIG_CRC16=y
 CONFIG_CRYPTO_CRC32C=y
 CONFIG_CRYPTO_HASH=y
@@ -52,9 +54,10 @@ CONFIG_CRYPTO_RNG2=y
 CONFIG_CRYPTO_WORKQUEUE=y
 CONFIG_DTC=y
 CONFIG_DWMAC_GENERIC=y
-# CONFIG_DWMAC_SUNXI is not set
 CONFIG_DW_APB_ICTL=y
 CONFIG_EXT4_FS=y
+# CONFIG_EZNPS_GIC is not set
+CONFIG_FIXED_PHY=y
 CONFIG_FS_MBCACHE=y
 CONFIG_GENERIC_ATOMIC64=y
 CONFIG_GENERIC_CLOCKEVENTS=y
@@ -63,12 +66,12 @@ CONFIG_GENERIC_FIND_FIRST_BIT=y
 CONFIG_GENERIC_IO=y
 CONFIG_GENERIC_IRQ_CHIP=y
 CONFIG_GENERIC_IRQ_SHOW=y
+CONFIG_GENERIC_PCI_IOMAP=y
 CONFIG_GENERIC_SMP_IDLE_THREAD=y
-# CONFIG_GEN_RTC is not set
 CONFIG_GPIOLIB=y
-CONFIG_GPIO_DEVRES=y
 CONFIG_GPIO_DWAPB=y
 CONFIG_GPIO_GENERIC=y
+CONFIG_HANDLE_DOMAIN_IRQ=y
 CONFIG_HAS_DMA=y
 CONFIG_HAS_IOMEM=y
 # CONFIG_HAVE_64BIT_ALIGNED_ACCESS is not set
@@ -80,9 +83,8 @@ CONFIG_HAVE_CLK=y
 CONFIG_HAVE_CLK_PREPARE=y
 CONFIG_HAVE_DEBUG_STACKOVERFLOW=y
 CONFIG_HAVE_FUTEX_CMPXCHG=y
-# CONFIG_HAVE_GENERIC_DMA_COHERENT is not set
+CONFIG_HAVE_GENERIC_DMA_COHERENT=y
 CONFIG_HAVE_IOREMAP_PROT=y
-CONFIG_HAVE_LATENCYTOP_SUPPORT=y
 CONFIG_HAVE_MEMBLOCK=y
 CONFIG_HAVE_MOD_ARCH_SPECIFIC=y
 CONFIG_HAVE_NET_DSA=y
@@ -97,12 +99,16 @@ CONFIG_ISA_ARCOMPACT=y
 # CONFIG_ISA_ARCV2 is not set
 CONFIG_JBD2=y
 CONFIG_KALLSYMS=y
+CONFIG_KERNEL_GZIP=y
+# CONFIG_LEDS_TRIGGER_MTD is not set
 CONFIG_LIBFDT=y
 CONFIG_LINUX_LINK_BASE=0x80000000
 CONFIG_LZO_COMPRESS=y
 CONFIG_LZO_DECOMPRESS=y
 CONFIG_MDIO_BOARDINFO=y
+# CONFIG_MDIO_HISI_FEMAC is not set
 CONFIG_MFD_SYSCON=y
+CONFIG_MIGHT_HAVE_PCI=y
 CONFIG_MMC=y
 CONFIG_MMC_BLOCK=y
 CONFIG_MMC_DW=y
@@ -112,6 +118,7 @@ CONFIG_MMC_DW_PLTFM=y
 CONFIG_MMC_SDHCI=y
 CONFIG_MMC_SDHCI_PLTFM=y
 CONFIG_MODULES_USE_ELF_RELA=y
+# CONFIG_MTD_PHYSMAP_OF_VERSATILE is not set
 CONFIG_NATIONAL_PHY=y
 CONFIG_NEED_PER_CPU_KM=y
 # CONFIG_NET_CADENCE is not set
@@ -137,8 +144,10 @@ CONFIG_OF_FLATTREE=y
 CONFIG_OF_GPIO=y
 CONFIG_OF_IRQ=y
 CONFIG_OF_MDIO=y
-CONFIG_OF_MTD=y
 CONFIG_OF_NET=y
+CONFIG_OF_RESERVED_MEM=y
+# CONFIG_PCI is not set
+# CONFIG_PCI_SYSCALL is not set
 CONFIG_PERF_USE_VMALLOC=y
 CONFIG_PGTABLE_LEVELS=2
 CONFIG_PHYLIB=y
@@ -148,13 +157,23 @@ CONFIG_PREEMPT_COUNT=y
 # CONFIG_PREEMPT_NONE is not set
 CONFIG_PREEMPT_RCU=y
 CONFIG_PTP_1588_CLOCK=y
+CONFIG_PWRSEQ_EMMC=y
+CONFIG_PWRSEQ_SIMPLE=y
 CONFIG_RATIONAL=y
 # CONFIG_RCU_BOOST is not set
 CONFIG_RCU_STALL_COMMON=y
 CONFIG_REGMAP=y
 CONFIG_REGMAP_MMIO=y
+# CONFIG_RESET_ATH79 is not set
+# CONFIG_RESET_BERLIN is not set
 CONFIG_RESET_CONTROLLER=y
-# CONFIG_RTC is not set
+# CONFIG_RESET_LPC18XX is not set
+# CONFIG_RESET_MESON is not set
+# CONFIG_RESET_PISTACHIO is not set
+# CONFIG_RESET_SOCFPGA is not set
+# CONFIG_RESET_STM32 is not set
+# CONFIG_RESET_SUNXI is not set
+# CONFIG_RESET_ZYNQ is not set
 # CONFIG_SCHED_INFO is not set
 # CONFIG_SCSI_DMA is not set
 CONFIG_SERIAL_8250_DEPRECATED_OPTIONS=y
@@ -166,13 +185,14 @@ CONFIG_SERIAL_ARC=y
 CONFIG_SERIAL_ARC_CONSOLE=y
 CONFIG_SERIAL_ARC_NR_PORTS=1
 CONFIG_SERIAL_OF_PLATFORM=y
+# CONFIG_SG_POOL is not set
 CONFIG_SRCU=y
 CONFIG_STACKTRACE=y
 CONFIG_STMMAC_ETH=y
 CONFIG_STMMAC_PLATFORM=y
+CONFIG_SWPHY=y
 CONFIG_SYSCTL_ARCH_UNALIGN_ALLOW=y
 CONFIG_SYSCTL_ARCH_UNALIGN_NO_WARN=y
 CONFIG_TICK_CPU_ACCOUNTING=y
 CONFIG_UNINLINE_SPIN_UNLOCK=y
 CONFIG_USB_SUPPORT=y
-CONFIG_ZONE_DMA_FLAG=0
diff --git a/target/linux/arc770/patches-4.4/001-ARC-arcompact-brown-paper-bag-bug-in-unaligned-access-delay-slot-fixup.patch b/target/linux/arc770/patches-4.9/001-ARC-arcompact-brown-paper-bag-bug-in-unaligned-access-delay-slot-fixup.patch
similarity index 100%
rename from target/linux/arc770/patches-4.4/001-ARC-arcompact-brown-paper-bag-bug-in-unaligned-access-delay-slot-fixup.patch
rename to target/linux/arc770/patches-4.9/001-ARC-arcompact-brown-paper-bag-bug-in-unaligned-access-delay-slot-fixup.patch
diff --git a/target/linux/arc770/patches-4.4/700-stmmac-Disable-frame-filtering-completely.patch b/target/linux/arc770/patches-4.9/700-stmmac-Disable-frame-filtering-completely.patch
similarity index 100%
rename from target/linux/arc770/patches-4.4/700-stmmac-Disable-frame-filtering-completely.patch
rename to target/linux/arc770/patches-4.9/700-stmmac-Disable-frame-filtering-completely.patch