diff --git a/target/linux/brcm63xx/base-files/etc/board.d/01_leds b/target/linux/brcm63xx/base-files/etc/board.d/01_leds
index 7d208cc..347de56 100755
--- a/target/linux/brcm63xx/base-files/etc/board.d/01_leds
+++ b/target/linux/brcm63xx/base-files/etc/board.d/01_leds
@@ -66,6 +66,9 @@ livebox1)
 	ucidef_set_led_netdev "wan" "WAN" "Livebox1:red:adsl" "eth1"
 	ucidef_set_led_netdev "wlan0" "WIFI" "Livebox1:red:wifi" "wlan0"
 	;;
+r1000h)
+	ucidef_set_led_usbport "usb" "USB" "R1000H:green:usb" "usb1-port1" "usb2-port1"
+	;;
 r5010un_v2)
 	ucidef_set_led_usbdev "usb" "USB" "R5010UNv2:green:usb" "1-1"
 	;;
diff --git a/target/linux/brcm63xx/base-files/etc/board.d/02_network b/target/linux/brcm63xx/base-files/etc/board.d/02_network
index ff5fc7a..d618ce3 100755
--- a/target/linux/brcm63xx/base-files/etc/board.d/02_network
+++ b/target/linux/brcm63xx/base-files/etc/board.d/02_network
@@ -12,6 +12,7 @@ case "$(brcm63xx_board_name)" in
 
 cvg834g |\
 evg2000 |\
+r1000h |\
 rta770bw |\
 rta770w |\
 spw303v |\
diff --git a/target/linux/brcm63xx/base-files/lib/brcm63xx.sh b/target/linux/brcm63xx/base-files/lib/brcm63xx.sh
index bceba8f..2d76b65 100755
--- a/target/linux/brcm63xx/base-files/lib/brcm63xx.sh
+++ b/target/linux/brcm63xx/base-files/lib/brcm63xx.sh
@@ -21,6 +21,9 @@ brcm63xx_dt_detect() {
 	"ADB P.DG AV4202N")
 		board_name="av4202n"
 		;;
+	"Actiontec R1000H")
+		board_name="r1000h"
+		;;
 	"Alcatel RG100A")
 		board_name="rg100a"
 		;;
diff --git a/target/linux/brcm63xx/dts/r1000h.dts b/target/linux/brcm63xx/dts/r1000h.dts
new file mode 100644
index 0000000..c8ecccd
--- /dev/null
+++ b/target/linux/brcm63xx/dts/r1000h.dts
@@ -0,0 +1,92 @@
+/dts-v1/;
+
+#include "bcm6368.dtsi"
+
+#include <dt-bindings/input/input.h>
+
+/ {
+	model = "Actiontec R1000H";
+	compatible = "actiontec,r1000h", "brcm,bcm6368";
+
+	chosen {
+		bootargs = "root=/dev/mtdblock2 rootfstype=squashfs noinitrd console=ttyS0,115200";
+	};
+
+	gpio-keys-polled {
+		compatible = "gpio-keys-polled";
+		#address-cells = <1>;
+		#size-cells = <0>;
+		poll-interval = <20>;
+		debounce-interval = <60>;
+
+		reset {
+			label = "reset";
+			gpios = <&gpio1 2 1>;
+			linux,code = <KEY_RESTART>;
+		};
+
+		wps {
+			label = "wps";
+			gpios = <&gpio1 3 1>;
+			linux,code = <KEY_WPS_BUTTON>;
+		};
+	};
+
+	gpio-leds {
+		compatible = "gpio-leds";
+
+		inet_green {
+			label = "R1000H:green:inet";
+			gpios = <&gpio0 5 0>;
+		};
+
+		usb_green {
+			label = "R1000H:green:usb";
+			gpios = <&gpio0 21 1>;
+		};
+
+		power_green {
+			label = "R1000H:green:power";
+			gpios = <&gpio0 22 0>;
+			default-state = "on";
+		};
+
+		wps_green {
+			label = "R1000H:green:wps";
+			gpios = <&gpio0 23 1>;
+		};
+
+		power_red {
+			label = "R1000H:red:power";
+			gpios = <&gpio0 24 0>;
+		};
+
+		wps_red {
+			label = "R1000H:red:wps";
+			gpios = <&gpio0 30 1>;
+		};
+
+		inet_red {
+			label = "R1000H:red:inet";
+			gpios = <&gpio0 31 0>;
+		};
+	};
+};
+
+&pflash {
+	status = "ok";
+
+	linux,part-probe = "bcm63xxpart";
+
+	CFE@0 {
+		reg = <0x000000 0x020000>;
+	};
+
+	linux@20000 {
+		reg = <0x020000 0x1fc0000>;
+	};
+
+	nvram@1fe0000 {
+		reg = <0x1fe0000 0x20000>;
+	};
+};
diff --git a/target/linux/brcm63xx/image/bcm63xx.mk b/target/linux/brcm63xx/image/bcm63xx.mk
index 0749c29..40701a4 100644
--- a/target/linux/brcm63xx/image/bcm63xx.mk
+++ b/target/linux/brcm63xx/image/bcm63xx.mk
@@ -1,3 +1,4 @@
+
 #
 # BCM33XX/BCM63XX Profiles
 #
@@ -174,6 +175,21 @@ define Device/96368MVWG-generic
 endef
 TARGET_DEVICES += 96368MVWG-generic
 
+### Actiontec ###
+define Device/R1000H
+  $(Device/bcm63xx)
+  FILESYSTEMS := squashfs
+  DEVICE_TITLE := Actiontec R1000H
+  DEVICE_DTS := r1000h
+  CFE_BOARD_ID := 96368MVWG
+  CFE_CHIP_ID := 6368
+	FLASH_MB := 4
+  IMAGE_OFFSET := 0x20000
+  DEVICE_PACKAGES := \
+    $(USB2_PACKAGES)
+endef
+TARGET_DEVICES += R1000H
+
 ### ADB ###
 define Device/A4001N
   $(Device/bcm63xx)
diff --git a/target/linux/brcm63xx/patches-4.4/578-board_R1000H.patch b/target/linux/brcm63xx/patches-4.4/578-board_R1000H.patch
new file mode 100644
index 0000000..fd27345
--- /dev/null
+++ b/target/linux/brcm63xx/patches-4.4/578-board_R1000H.patch
@@ -0,0 +1,63 @@
+--- a/arch/mips/bcm63xx/boards/board_bcm963xx.c
++++ b/arch/mips/bcm63xx/boards/board_bcm963xx.c
+@@ -2203,6 +2203,44 @@ static struct board_info __initdata boar
+ 	},
+ };
+ 
++static struct board_info __initdata board_R1000H = {
++	.name				= "R1000H",
++	.expected_cpu_id		= 0x6368,
++
++	.has_uart0			= 1,
++	.has_uart1			= 1,
++	.has_pci			= 1,
++	.has_ohci0			= 1,
++	.has_ehci0			= 1,
++	.has_usbd			= 1,
++	.usbd = {
++		.use_fullspeed		= 0,
++		.port_no		= 0,
++	},
++
++	.has_enetsw			= 1,
++	.enetsw = {
++		.used_ports = {
++			[4] = {
++				.used  = 1,
++				.phy_id  = 0xff,
++				.bypass_link = 1,
++				.force_speed = 1000,
++				.force_duplex_full = 1,
++				.name  = "port4",
++			},
++			[5] = {
++				.used  = 1,
++				.phy_id  = 0xff,
++				.bypass_link = 1,
++				.force_speed = 1000,
++				.force_duplex_full = 1,
++				.name  = "RGMII",
++			},
++		},
++	},
++};
++
+ static struct board_info __initdata board_VR3025u = {
+ 	.name					= "96368M-1541N",
+ 	.expected_cpu_id		= 0x6368,
+@@ -2701,6 +2739,7 @@ static const struct board_info __initcon
+ 	&board_HG622,
+ 	&board_HG655b,
+ 	&board_P870HW51A_V2,
++	&board_R1000H,
+ 	&board_VH4032N,
+ 	&board_VR3025u,
+ 	&board_VR3025un,
+@@ -2802,6 +2841,7 @@ static struct of_device_id const bcm963x
+ 	{ .compatible = "sfr,nb6-ser-r0", .data = &board_nb6, },
+ #endif
+ #ifdef CONFIG_BCM63XX_CPU_6368
++	{ .compatible = "actiontec,r1000h", .data = &board_R1000H, },
+ 	{ .compatible = "adb,av4202n", .data = &board_AV4202N, },
+ 	{ .compatible = "brcm,bcm96368mvngr", .data = &board_96368mvngr, },
+ 	{ .compatible = "brcm,bcm96368mvwg", .data = &board_96368mvwg, },